Summary:        Easily download, build, install, upgrade, and uninstall Python packages
Name:           python-setuptools
Version:        62.3.2
Release:        4%{?dist}
License:        MIT and (BSD or ASL 2.0)
URL:            https://github.com/pypa/setuptools
Source0:        %{url}/archive/v%{version}/v%{version}.tar.gz
# remove mock in tests, helped by https://build.opensuse.org/package/view_file/openSUSE:Factory/python-setuptools/remove_mock.patch
Patch5000:      62.3.2-remove-mock-in-tests.patch
# skip some test cases, please look at comments in patch file in detail
Patch5001:      62.3.2-skip-unsopported-test-cases.patch

BuildRequires:  python3-devel, python3-setuptools, python3-pip, python3-rpm-generators, pyproject-rpm-macros
# only needed for tests
BuildRequires:  gcc, python3-pytest, python3-path, python3-jaraco-envs, python3-jaraco-path, python3-wheel, python3-pytest-xdist, python3-pytest-forked, python3-pytest-fixture-config, python3-pytest-virtualenv, python3-tomli

BuildArch:      noarch

%description
Setuptools is a fully-featured, actively-maintained, and stable library
designed to facilitate packaging Python projects.

This package also contains the runtime components of setuptools, necessary to
execute the software that requires pkg_resources.

# these bundles are generated by following command:
# cat pkg_resources/_vendor/vendored.txt setuptools/_vendor/vendored.txt > allvendor.txt
# %%{_rpmconfigdir}/pythonbundles.py allvendor.txt --namespace 'python3dist'
%global bundled %{expand:
Provides: bundled(python3dist(appdirs)) = 1.4.3
Provides: bundled(python3dist(importlib-metadata)) = 4.11.1
Provides: bundled(python3dist(importlib-resources)) = 5.4
Provides: bundled(python3dist(jaraco-text)) = 3.7
Provides: bundled(python3dist(more-itertools)) = 8.8
Provides: bundled(python3dist(nspektr)) = 0.3
Provides: bundled(python3dist(ordered-set)) = 3.1.1
Provides: bundled(python3dist(packaging)) = 21.3
Provides: bundled(python3dist(pyparsing)) = 3.0.8
Provides: bundled(python3dist(tomli)) = 2.0.1
Provides: bundled(python3dist(typing-extensions)) = 4.0.1
Provides: bundled(python3dist(zipp)) = 3.7
}

%package -n python3-setuptools
Summary:        Easily download, build, install, upgrade, and uninstall Python3 packages
%{bundled}
Provides:       python3dist(setuptools) = %{version}
Provides:       python%{python3_version}dist(setuptools) = %{version}
Provides:       python3-pkg_resources = %{version}-%{release}

%description -n python3-setuptools
Setuptools is a fully-featured, actively-maintained, and stable library
designed to facilitate packaging Python projects.

This package also contains the runtime components of setuptools, necessary to
execute the software that requires pkg_resources.

	
%package -n python-setuptools-wheel
Summary:        The setuptools wheel
%{bundled}
 
%description -n python-setuptools-wheel
A Python wheel of setuptools to use with venv.



%prep
%autosetup -p1 -n setuptools-%{version}



%build
%pyproject_wheel


%install
%pyproject_install
mv %{buildroot}%{python3_sitelib}/setuptools-%{version}.*.dist-info/ %{buildroot}%{python3_sitelib}/setuptools-%{version}.dist-info/

mkdir -p %{buildroot}%{python_wheel_dir}
install -p %{_pyproject_wheeldir}/setuptools-%{version}*.whl -t %{buildroot}%{python_wheel_dir}/



%check
# Verify bundled provides are up to date
cat pkg_resources/_vendor/vendored.txt setuptools/_vendor/vendored.txt > allvendor.txt
%{_rpmconfigdir}/pythonbundles.py allvendor.txt --namespace 'python3dist' --compare-with '%{bundled}'
SETUPTOOLS_WHEEL=$(find . -name "setuptools-%{version}*.whl")
PRE_BUILT_SETUPTOOLS_WHEEL=${SETUPTOOLS_WHEEL} PYTHONPATH=$(pwd):${PYTHONPATH} %pytest



%files -n python3-setuptools
%license LICENSE
%doc docs/* CHANGES.rst README.rst
%{python3_sitelib}/distutils-precedence.pth
%{python3_sitelib}/setuptools-%{version}.dist-info/
%{python3_sitelib}/pkg_resources/
%{python3_sitelib}/setuptools/
%{python3_sitelib}/_distutils_hack/

%files -n python-setuptools-wheel
%license LICENSE
%{python_wheel_dir}/



%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 62.3.2-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 62.3.2-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 62.3.2-2
- Rebuilt for OpenCloudOS Stream 23

* Thu May 26 2022 Zhao Zhen <jeremiazhao@tencent.com> - 62.3.2-1
- Initial building.
